Package org.zkoss.zul

## Enum Window.Mode

- java.lang.Object
- - java.lang.Enum<Window.Mode>
  - - org.zkoss.zul.Window.Mode

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Comparable<Window.Mode>`
  Enclosing class:
    Window

      public static enum Window.Mode
      extends java.lang.Enum<Window.Mode>

  The window's mode used with `Window.setMode(Mode)`.
  Since:
    6.0.0

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `EMBEDDED` | Embeds the window as normal component.
    `HIGHLIGHTED` | Makes the window as highlighted.
    `MODAL` | Makes the window as a modal dialog. once `Window.doModal()` is called, the execution of the event processing thread is suspended until one of the following occurs.
    `OVERLAPPED` | Makes the window as overlapped other components.
    `POPUP` | Makes the window as popup.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static Window.Mode` | `valueOf​(java.lang.String name)` | Returns the enum constant of this type with the specified name.
    `static Window.Mode[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### EMBEDDED

          public static final Window.Mode EMBEDDED

      Embeds the window as normal component.

    - #### MODAL

          public static final Window.Mode MODAL

      Makes the window as a modal dialog. once `Window.doModal()` is called, the execution of the event processing thread is suspended until one of the following occurs.
      1. `Window.setMode(Mode)` is called with a mode other than MODAL.
      2. Either `Window.doOverlapped()`, `Window.doPopup()`, `Window.doEmbedded()`, or `Window.doHighlighted()` is called.
      3. `Window.setVisible(boolean)` is called with false.
      4. The window is detached from the window.

      Note: In the last two cases, the mode becomes `OVERLAPPED`. In other words, one might say a modal window is a special overlapped window.

      See Also:
        `HIGHLIGHTED`

    - #### OVERLAPPED

          public static final Window.Mode OVERLAPPED

      Makes the window as overlapped other components.

    - #### POPUP

          public static final Window.Mode POPUP

      Makes the window as popup. It is similar to `OVERLAPPED`, except it is auto hidden when user clicks outside of the window.

    - #### HIGHLIGHTED

          public static final Window.Mode HIGHLIGHTED

      Makes the window as highlighted. Its visual effect is the same as `MODAL`. However, from the server side's viewpoint, it is similar to `OVERLAPPED`. The execution won't be suspended when `Window.doHighlighted()` is called.
      See Also:
        `MODAL`, `OVERLAPPED`

  - ### Method Detail

    - #### values

          public static Window.Mode[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (Window.Mode c : Window.Mode.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static Window.Mode valueOf​(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null